<?php
# ----------------- maak hier uw aanpassingen ----------------------------------
$hwaID 		= 165; 					# Voor xxx je ID invullen
$security 	= "9766527f2b5d3e95d4a733fcfb77bd7e"; 	# Voor xxx je code invullen
$aantal_dgn	= 8; 					# Aantal dagen, max = 9, alleen als niet ruinen of niet hwa is gekozen
$compatible     = false;
#$compatible     = array('ruinen',376, 558, 5);          # 376 hoog - 558 breed 5 dagen
#$compatible     = array('hwa',   389, 550, 5);          # 389 hoog - 550 breed 5 dagen
# Voor zelfde formaat zet alleen die regel die je wilt gebruiken, rest op commentaar = # 1e positie
# als op false wordt op basis van het aantal dagen
#-------------------------------------------------------------------------------
# ***** kleuren  in rgb *****

$kleur_van      = array( 183, 212, 228);        // achtergrond verloop 
$kleur_tot      = array( 95, 159, 203);         // idem
$kleur_max	= array( 255, 238, 82);         // temp blokje dag
$kleur_min	= array( 200, 200, 200);        // temp blokje nacht         
$kleur_txt	= array( 235, 235, 235);        // standaard tekst 
$kleur_dag	= array( 137, 165, 204);        // dagnaam
$kleur_temp	= array(   0,   0,   0);        // temp in blokje 
$kleur_balk	= array( 123, 171, 209);        // balkje als scheiding tussen dagen 
#--------------------- grootte gebruikte teksten in punten ---------------------
#
$wind_txt	= 16;	// windkracht in bft
$dag_txt	= 44;	// di wo enzovoort
$temp_txt	= 16;	// temp in het vakje
$tekst_txt	= 10;	// woorden als wind neerslag mm
$regen_txt	= 16;	// aantal mm regen
#                       lokatie font file
$font_file      = 'PFDinDisplayPro-Bold.ttf';
$anti_alias     = 'false';
#                       gebruiktye iconen
$img_folder     = 'images/';    // map waar de afbeeldingen staan
$img_ext        = '.png';       // type afbeeldingen weersymbool
#                       cache settings
$cache_folder   = 'cache/';     // map
$cache_time     = 3600;         // 3600 secondes = 1 uur, zet op 0 voor testen e.d.
#-------------------------------------------------------------------------------
ob_start();
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) { 
           $filenameReal = __FILE__;			# display source of script if requested so
           $download_size = filesize($filenameReal);
           header('Pragma: public');
           header('Cache-Control: private');
           header('Cache-Control: no-cache, must-revalidate');
           header("Content-type: text/plain");
           header("Accept-Ranges: bytes");
           header("Content-Length: $download_size");
           header('Connection: close');
           readfile($filenameReal);
           exit;
}
$pageName	= $wsMos = 'wsMos1.php';
$pageVersion	= '0.00 2016-07-07';
#-------------------------------------------------------------------------------
# 0.00 2016-07-07   MOS  png  NEW xml feed - fout met regen calculatie verwijderd 
#-------------------------------------------------------------------------------
ob_start();
$wsDebug = true;
check_ws_message();
$pathString	= '';   // here we store all messages until html is outputted
$forecast_url= "http://www.hetweeractueel.nl/includes/custom/mosfeed.php?id=".
	$hwaID."&securitycode=".
	$security."&extended=1&source=met.no";
#$test = './test.xml';
$test = false;
if ($test <> false) {$cache_time = 0;}

#       controleer of er een correct plaatje in de cache staat
$cache_file     = $cache_folder.'mos1'.$hwaID.$img_ext;
if (file_exists($cache_file)){
        $file_time      = filemtime($cache_file);
        $age            = time() - $file_time;
        if ($age < $cache_time) {       // cache valid, stuur cache file
                $im     = @imagecreatefrompng ($cache_file);
                if ($im) {
                        ob_end_clean ();
                        header('Content-type: image/png');
                        imagepng($im);
                        imagedestroy($im);
                        exit;
                }
        }
}
#       blijkbaar geen og geen goede file in cache, dus maken we hem
#       eerst de verwachting ophalen
$xml= makeRequest($forecast_url);
if (!$xml) {echo 'error'; return;}	#############

#echo '<pre>'.print_r($xml,true); exit;

$station_naam	= (string) $xml->Plaatsen->Plaats['naam'];
$gemaakt_op 	= (string) $xml['aanmaakdatum'].' '.(string) $xml['aanmaaktijd'];

$mos_array = array();
#
foreach($xml->Plaatsen->Plaats->Verwachtingen->Verwachting as $verwachting) {
#
#	eerst de verwachtingen samenvoegen tot 1 voor de dag (max) en 1 voor de nacht (min)
	$keymax    = (string) $verwachting['dagnaam'].'max'.(string) $verwachting['dag'];
    $keymin    = (string) $verwachting['dagnaam'].'min'.(string) $verwachting['dag'];
	switch ($verwachting['uur']) {
		case 12:	# ochtend => dag max
		case 18:  	# middag  => dag max
			$mos_array[$keymax]['dag']  = (string) $verwachting['dagnaam'];
			$mos_array[$keymax]['type'] = 'max';
			if (!isset ($mos_array[$keymax]['neerslaghoeveelheid'])){
				$mos_array[$keymax]['neerslaghoeveelheid'] = 0;
			}
			$mos_array[$keymax]['neerslaghoeveelheid'] += (float) $verwachting->neerslaghoeveelheid;   
			if (isset ($verwachting->maximumtemperatuur) ) {
				$value = (float) $verwachting->maximumtemperatuur;
			} else {	
				$value = (float) $verwachting->temperatuur;
			}
			if (!isset ($mos_array[$keymax]['maximumtemperatuur']) ){
				$mos_array[$keymax]['maximumtemperatuur'] = $value;
			}
			elseif ($value > $mos_array[$keymax]['maximumtemperatuur']) {
				$mos_array[$keymax]['maximumtemperatuur'] = $value;
			}
			$value = (float) $verwachting->windsnelheid;
			if (!isset($mos_array[$keymax]['windsnelheid']) ){
				$mos_array[$keymax]['windsnelheid'] = $value;
			}
			elseif ($value > $mos_array[$keymax]['windsnelheid']) {
				$mos_array[$keymax]['windsnelheid'] = $value;
			}
			$mos_array[$keymax]['windrichting'] 	= (string) $verwachting->windrichting;
			$mos_array[$keymax]['weersymbool_12u']	= (float) $verwachting->weersymbool;
			break;
		case 0:	# avond => nacht min
        case 6: # nacht min
			$mos_array[$keymin]['dag']  = (string) $verwachting['dagnaam'];
			$mos_array[$keymin]['type'] = 'min';
			if (!isset ($mos_array[$keymin]['neerslaghoeveelheid'])){
				$mos_array[$keymin]['neerslaghoeveelheid'] = 0;
			}
			$mos_array[$keymin]['neerslaghoeveelheid'] += (float) $verwachting->neerslaghoeveelheid;   
			if (isset ($verwachting->maximumtemperatuur) ) {
				$value = (float) $verwachting->minimumtemperatuur;
			} else {	
				$value = (float) $verwachting->temperatuur;
			}
			if (!isset ($mos_array[$keymin]['minimumtemperatuur']) ){
				$mos_array[$keymin]['minimumtemperatuur'] = $value;
			}
			elseif ($value < $mos_array[$keymin]['minimumtemperatuur']) {
				$mos_array[$keymin]['minimumtemperatuur'] = $value;
			}
			$value = (float) $verwachting->windsnelheid;
			if (!isset($mos_array[$keymin]['windsnelheid']) ){
				$mos_array[$keymin]['windsnelheid'] = $value;
			}
			elseif ($value > $mos_array[$keymin]['windsnelheid']) {
				$mos_array[$keymin]['windsnelheid'] = $value;
			}
			$mos_array[$keymin]['windrichting'] 	= (string) $verwachting->windrichting;
			$mos_array[$keymin]['weersymbool_12u']	= (float) $verwachting->weersymbool;
			break;
	}	// eo switch
} // eo each forecast
#echo '<pre>'.$pathString.print_r($mos_array,true); exit;
/* Array ziet er uit als
    [Dinsdagmax21] => Array
        (   [dag] => Dinsdag
            [type] => max
            [neerslaghoeveelheid] => 0
            [maximumtemperatuur] => 21
            [windsnelheid] => 3
            [windrichting] => zw
            [weersymbool_12u] => 11
        )    */
#array_shift($mos_array);       // for testing only
#
#	bepaal marges links / rechts 
$marge_links	= 4;
if (!isset ($compatible))       { $compatible = false; }
elseif (!is_array($compatible)) { $compatible = false; }
elseif (!isset ($compatible[0])){ $compatible = false; }
#
if ($compatible == false ) {
        $hoogte_mos	= 376;  //376 * 558  = Ruinen-Mos  389 * 550 = HWA mos
        if ($aantal_dgn > 9) {$aantal_dgn = 9;}
        $dagen_file	= floor(count ($mos_array) / 2);
        if ($aantal_dgn > $dagen_file) {$aantal_dgn = $dagen_file;}

        $breedte_mos	= 4 + ($aantal_dgn * 110) + 4 ;
}
else {  $hoogte_mos	= $compatible[1];
        $breedte_mos    = $compatible[2];
        $aantal_dgn     = $compatible[3];
        $marge_links	+= 20;
}
#
$geen_dag       = 0;
foreach ($mos_array as $deel) {
        if ($deel['type'] <> 'max') { // eerste deel is nacht
                $geen_dag       = -20;
        }
        break;
}
#
# maak image en vul met verloopkleur
$im             = imagecreatetruecolor($breedte_mos, $hoogte_mos); 
imagecolorgradient($im, 0, 0, $hoogte_mos, $breedte_mos,  $kleur_van, $kleur_tot);
#
# maak kleuren
$color_max	= imagecolorallocate($im, $kleur_max[0], $kleur_max[1],  $kleur_max[2]);
$color_min	= imagecolorallocate($im, $kleur_min[0], $kleur_min[1],  $kleur_min[2]);
$color_txt	= imagecolorallocate($im, $kleur_txt[0], $kleur_txt[1],  $kleur_txt[2]);
$color_dag	= imagecolorallocate($im, $kleur_dag[0], $kleur_dag[1],  $kleur_dag[2]);
$color_temp	= imagecolorallocate($im, $kleur_temp[0],$kleur_temp[1], $kleur_temp[2]);
$color_balk     = imagecolorallocate($im, $kleur_balk[0],$kleur_balk[1], $kleur_balk[2]);
#
# alles wat getekend moet worden
ImageTTFText ($im, 14, 0, 15, 25, $color_txt, "$font_file","Vooruitzichten voor $station_naam");
$n      = 1;    
$dag    = 1;
foreach ($mos_array as $deel) {
        if ($dag > $aantal_dgn) {break;}
        $x_left = 20 + ($dag - 1) * 110;
        $x_right= $x_left + 40;
        if ($deel['type'] <> 'max') {
 # deze gegevens worden altijd gemaakt
                // dagnaam
                imagecenteredtext       ($x_left+40,     85,  strtolower(substr($deel['dag'],0,2)), 5, $dag_txt, $color_dag, 0);
                // verklarende tekst
                imagecenteredtext 	($x_left+40,    220,  "wind",     5,       $tekst_txt,  $color_txt, 0); 
                imagecenteredtext       ($x_left+40,    305,  "neerslag", 5, $tekst_txt,  $color_txt, 0);
# deze gegevens worden altijd gemaakt behalve laatste dag
                // afsluitende streep
                if ($dag <> $aantal_dgn) {
                        imagefilledrectangle ($im,$x_left+94, 35, $x_left + 96, 352, $color_dag); 
                }
# de  nacht gegevens
                $x_right        += $geen_dag;
                imagefilledrectangle ($im, $x_right,    150,  $x_right + 38, 185, $color_min);	# nacht vakje
                imagecenteredtext       (  $x_right+20, 175,  $deel['minimumtemperatuur'],  5, $temp_txt,  $color_temp, 0);
                imagecenteredtext       (  $x_right+20, 275,  $deel['windsnelheid'],        5, $wind_txt,  $color_txt,  0);
                imagecenteredtext       (  $x_right+20, 330,  $deel['neerslaghoeveelheid'], 5, $regen_txt, $color_txt,  0);
                imagecenteredtext       (  $x_right+20, 340,  "mm",                         5, $tekst_txt, $color_txt,  0);
                $var    = imagecreatefrompng($img_folder.$deel['windrichting'].$img_ext);
                $icon_x = imagesx($var);
                $icon_y = imagesy($var);
                imagecopy      ($im, $var, $x_right+5,  230, 0, 0, $icon_x, $icon_y); 
                $var    = imagecreatefrompng($img_folder.$deel['weersymbool_12u'].$img_ext);
                $icon_x = imagesx($var);
                $icon_y = imagesy($var);
                imagecopyresized($im,$var, $x_right-5,    95, 0, 0, 50, 50, $icon_x, $icon_y);
                $geen_dag = 0;
        }
        else {
 # de dag gegevens        
                imagefilledrectangle ($im, $x_left,     150, $x_left + 38, 185, $color_max);	# dag vakje
                imagecenteredtext       (  $x_left+20,  175, $deel['maximumtemperatuur'],   5, $temp_txt,  $color_temp, 0);
                imagecenteredtext       (  $x_left+20,  275, $deel['windsnelheid'],         5, $wind_txt,  $color_txt,  0);
                imagecenteredtext       (  $x_left+20,  330, $deel['neerslaghoeveelheid'],  5, $regen_txt, $color_txt,  0);
                imagecenteredtext       (  $x_left+20,  340,  "mm",                         5, $tekst_txt, $color_txt,  0);
                $var    = imagecreatefrompng($img_folder.$deel['windrichting'].$img_ext);
                $icon_x = imagesx($var);
                $icon_y = imagesy($var);
                imagecopy      ($im, $var, $x_left+5,   230, 0, 0, $icon_x, $icon_y); 
                $var    = imagecreatefrompng($img_folder.$deel['weersymbool_12u'].$img_ext);
                $icon_x = imagesx($var);
                $icon_y = imagesy($var);
                imagecopyresized($im,$var, $x_left-5,    95, 0, 0, 50, 50, $icon_x, $icon_y);      
        }
        $n++;
        if ($deel['type'] <> 'max') {$dag++;}
}
#exit;
#
#
ob_end_clean ();
header('Content-type: image/png');
imagepng($im);
imagepng($im,$cache_file,0,NULL);
imagedestroy($im);		
	
#
function makeRequest($url){
	global $test, $wsMos ;
	if (!isset ($test) || $test <> false) {
		$raw_data  = file_get_contents($test);
		ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): data loaded from test file   -->',false);
	} else {	
		ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): data loaded from '.$url.'-->',false );
		$ch = curl_init();
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
		curl_setopt ($ch, CURLOPT_TIMEOUT, 10);
		$raw_data = curl_exec ($ch);
		curl_close ($ch);
	}
	if (empty($raw_data)){ 
		return false;
	}
#
# Check validity of returned file
#
	$data_ok= true;
	#
	$data   = trim($raw_data);		
	libxml_use_internal_errors(true);
	libxml_clear_errors();
	$doc    = new DOMDocument('1.0', 'utf-8');
	$doc->loadXML($data);
	$errors = libxml_get_errors();
	unset ($doc);
	if(!empty($errors)){
		foreach(libxml_get_errors() as $error) {
			ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): error '.trim($error->message).' -->',true );
		}
		$data_ok= false;
	}
	if ($data_ok == true) {
		$find   = '</Verwachting>';
		$end    = strlen($data) - strlen($find);
		$found  = strrpos($data,$find);
		if ($found <> $end) {
			ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): bad formatted end of xml'.$found.'-'.$end.' -->',true );
			$data_ok= false;
		}
	}
	if ($data_ok == true) {
		libxml_clear_errors();
		$data = new SimpleXMLElement(trim($raw_data) );
		if ($data === false) {
			ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): errors processing xml  -->',true );
			foreach(libxml_get_errors() as $error) {
					ws_message('<!-- module '.$wsMos.' => makeRequest ('.__LINE__.'): error '.$error->message.' -->',true );
			}
			libxml_clear_errors();
			$data_ok= false;
		}
	}
	if ($data_ok == false) {
		return false;	
	}
	return $data;		
} // eof makeRequest
function check_ws_message() {
        global $wsDebug, $SITE;
        if (function_exists ('ws_message') ){ return;}
        function ws_message ($message,$always=false,&$string=false) {
                global $wsDebug, $SITE;
                $echo	= $always;
                if ( isset ($wsDebug)           && $wsDebug == true ) 		{$echo = true;}
                if ( isset ($SITE['wsDebug'])   && $SITE['wsDebug'] == true ) 	{$echo = true;}
                if ( $echo ) {
                        if ( $string === false) { echo $message.PHP_EOL;}
                        else                    { $string .= $message.PHP_EOL;} 
                }    
        }
}
function imagecolorgradient($im, $x1, $y1, $height, $width,$left_color, $right_color) { 
    $color0=($left_color[0]-$right_color[0])/$height; 
    $color1=($left_color[1]-$right_color[1])/$height; 
    $color2=($left_color[2]-$right_color[2])/$height; 
    for ($i=0;$i<=$height;$i++) { 
        $red=$left_color[0]-floor($i*$color0); 
        $green=$left_color[1]-floor($i*$color1); 
        $blue=$left_color[2]-floor($i*$color2); 
        $col= imagecolorallocate($im, $red, $green, $blue); 
        imageline($im, $x1, $y1+$i, $x1+$width, $y1+$i, $col); 
    } 
} // eof imagecolorgradient
function imagecenteredtext($x, $y, $text, $size, $ttfsize, $color, $angle) {
  global $font_file, $im, $anti_alias ;
  // if FreeType is not supported OR $font_file is set to none
  // we'll use the GD default fonts
  $gdinf = gd_info();
  if (($gdinf["FreeType Support"] == 0) or ($font_file == "none")) {
     //  $x -= (imagefontwidth($size) * strlen($text)) / 2;
       $y -= (imagefontheight($size)) / 2;
       imagestring($im, $size, $x, $y - 3, $text, $color);
  } // end if

  // otherwise we'll use the truetype font defined in $font_file
  else {
     $box = imagettfbbox ($ttfsize, $angle, $font_file, $text);
     $x -= ($box[2] - $box[0]) / 2;
     $y -= ($box[3] - $box[1]) / 2;
     if ($anti_alias == 'off'){
        imagettftext ($im, $ttfsize, $angle, $x, $y, -$color, $font_file, $text);
     } // end if
     else {
          imagettftext ($im, $ttfsize, $angle, $x, $y, $color, $font_file, $text);
     } // end else
  } // end else

} // end function imagecenteredtext		
